# Leviton Cloud Services API model ActionBlock.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ActionBlock(BaseModel):
    def __init__(self, session, model_id=None):
        super(ActionBlock, self).__init__(session, model_id)

    @classmethod
    def count(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/count"
        return session.call_api(api, attribs, 'get')

    def count_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions/count".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks"
        return session.call_api(api, attribs, 'post')

    def create_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def create_many(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks"
        return session.call_api(api, attribs, 'post')

    def delete_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def delete_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_by_id_actions(self, action_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions/{1}".format(self._id, action_id)
        return self._session.call_api(api, attribs, 'delete')

    def exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/exists".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def find(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks"
        items = session.call_api(api, attribs, 'get')

        result = []
        if items is not None:
            for data in items:
                model = ActionBlock(session, data['id'])
                model.data = data
                result.append(model)
        return result

    def find_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        self.data.update(data)
        return self

    def find_by_id_actions(self, action_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions/{1}".format(self._id, action_id)
        data = self._session.call_api(api, attribs, 'get')

        from .action import Action
        model = Action(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def find_one(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/findOne"
        return session.call_api(api, attribs, 'get')

    def refresh(self):
        api = "/ActionBlocks/{0}".format(self._id)
        result = self._session.call_api(api, {}, 'get')
        if result is not None:
            self.data.update(result)
        return self

    def get_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions".format(self._id)
        items = self._session.call_api(api, attribs, 'get')

        from .action import Action
        result = []
        if items is not None:
            for data in items:
                model = Action(self._session, data['id'])
                model.data = data
                result.append(model)
        return result

    def get_activity(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/activity".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .activity import Activity
        model = Activity(self._session, data['id'])
        model.data = data
        return model

    def get_installation(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/installation".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .installation import Installation
        model = Installation(self._session, data['id'])
        model.data = data
        return model

    def replace_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/replace".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def replace_or_create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/replaceOrCreate"
        return session.call_api(api, attribs, 'post')

    def update_attributes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'put')

        self.data.update(attribs)
        return self

    def update_by_id_actions(self, action_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/{0}/actions/{1}".format(self._id, action_id)
        data = self._session.call_api(api, attribs, 'put')

        from .action import Action
        model = Action(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks"
        data = session.call_api(api, attribs, 'put')

        model = ActionBlock(session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert_with_where(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ActionBlocks/upsertWithWhere"
        return session.call_api(api, attribs, 'post')

