# Leviton Cloud Services API model Controller.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class Controller(BaseModel):
    def __init__(self, session, model_id=None):
        super(Controller, self).__init__(session, model_id)

    @classmethod
    def count(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/count"
        return session.call_api(api, attribs, 'get')

    def count_thermostats(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats/count".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers"
        return session.call_api(api, attribs, 'post')

    @classmethod
    def create_many(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers"
        return session.call_api(api, attribs, 'post')

    def create_thermostats(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    def delete_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def delete_thermostats(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_by_id_thermostats(self, thermostat_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats/{1}".format(self._id, thermostat_id)
        return self._session.call_api(api, attribs, 'delete')

    def discover(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/discover".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    def exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/exists".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def find(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers"
        items = session.call_api(api, attribs, 'get')

        result = []
        if items is not None:
            for data in items:
                model = Controller(session, data['id'])
                model.data = data
                result.append(model)
        return result

    def find_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        self.data.update(data)
        return self

    def find_by_id_thermostats(self, thermostat_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats/{1}".format(self._id, thermostat_id)
        data = self._session.call_api(api, attribs, 'get')

        from .thermostat import Thermostat
        model = Thermostat(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def find_one(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/findOne"
        return session.call_api(api, attribs, 'get')

    def refresh(self):
        api = "/Controllers/{0}".format(self._id)
        result = self._session.call_api(api, {}, 'get')
        if result is not None:
            self.data.update(result)
        return self

    def get_installation(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/installation".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .installation import Installation
        model = Installation(self._session, data['id'])
        model.data = data
        return model

    def get_thermostats(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats".format(self._id)
        items = self._session.call_api(api, attribs, 'get')

        from .thermostat import Thermostat
        result = []
        if items is not None:
            for data in items:
                model = Thermostat(self._session, data['id'])
                model.data = data
                result.append(model)
        return result

    def post_message(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/postMessage".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    def replace_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/replace".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def replace_or_create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/replaceOrCreate"
        return session.call_api(api, attribs, 'post')

    def update_attributes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'put')

        self.data.update(attribs)
        return self

    def update_by_id_thermostats(self, thermostat_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/{0}/thermostats/{1}".format(self._id, thermostat_id)
        data = self._session.call_api(api, attribs, 'put')

        from .thermostat import Thermostat
        model = Thermostat(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers"
        data = session.call_api(api, attribs, 'put')

        model = Controller(session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert_with_where(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/Controllers/upsertWithWhere"
        return session.call_api(api, attribs, 'post')

