# Leviton Cloud Services API model ResidentialAccount.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ResidentialAccount(BaseModel):
    def __init__(self, session, model_id=None):
        super(ResidentialAccount, self).__init__(session, model_id)

    @classmethod
    def count(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/count"
        return session.call_api(api, attribs, 'get')

    def count_residences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences/count".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    def count_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/count".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts"
        return session.call_api(api, attribs, 'post')

    @classmethod
    def create_many(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts"
        return session.call_api(api, attribs, 'post')

    def create_residences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    def create_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    def delete_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def delete_residences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def delete_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_by_id_residences(self, residence_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences/{1}".format(self._id, residence_id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_by_id_residential_partners(self, residential_partner_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/{1}".format(self._id, residential_partner_id)
        return self._session.call_api(api, attribs, 'delete')

    def exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/exists".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def find(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts"
        items = session.call_api(api, attribs, 'get')

        result = []
        if items is not None:
            for data in items:
                model = ResidentialAccount(session, data['id'])
                model.data = data
                result.append(model)
        return result

    def find_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        self.data.update(data)
        return self

    def find_by_id_residences(self, residence_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences/{1}".format(self._id, residence_id)
        data = self._session.call_api(api, attribs, 'get')

        from .residence import Residence
        model = Residence(self._session, data['id'])
        model.data = data
        return model

    def find_by_id_residential_partners(self, residential_partner_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/{1}".format(self._id, residential_partner_id)
        data = self._session.call_api(api, attribs, 'get')

        from .residential_partner import ResidentialPartner
        model = ResidentialPartner(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def find_one(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/findOne"
        return session.call_api(api, attribs, 'get')

    def refresh(self):
        api = "/ResidentialAccounts/{0}".format(self._id)
        result = self._session.call_api(api, {}, 'get')
        if result is not None:
            self.data.update(result)
        return self

    def get_residences(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences".format(self._id)
        items = self._session.call_api(api, attribs, 'get')

        from .residence import Residence
        result = []
        if items is not None:
            for data in items:
                model = Residence(self._session, data['id'])
                model.data = data
                result.append(model)
        return result

    def get_residential_partners(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners".format(self._id)
        items = self._session.call_api(api, attribs, 'get')

        from .residential_partner import ResidentialPartner
        result = []
        if items is not None:
            for data in items:
                model = ResidentialPartner(self._session, data['id'])
                model.data = data
                result.append(model)
        return result

    def replace_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/replace".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def replace_or_create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/replaceOrCreate"
        return session.call_api(api, attribs, 'post')

    def update_attributes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'put')

        self.data.update(attribs)
        return self

    def update_by_id_residences(self, residence_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residences/{1}".format(self._id, residence_id)
        data = self._session.call_api(api, attribs, 'put')

        from .residence import Residence
        model = Residence(self._session, data['id'])
        model.data = data
        return model

    def update_by_id_residential_partners(self, residential_partner_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/{0}/residentialPartners/{1}".format(self._id, residential_partner_id)
        data = self._session.call_api(api, attribs, 'put')

        from .residential_partner import ResidentialPartner
        model = ResidentialPartner(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts"
        data = session.call_api(api, attribs, 'put')

        model = ResidentialAccount(session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert_with_where(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialAccounts/upsertWithWhere"
        return session.call_api(api, attribs, 'post')

