# Leviton Cloud Services API model ResidentialBreakerPanel.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ResidentialBreakerPanel(BaseModel):
    def __init__(self, session, model_id=None):
        super(ResidentialBreakerPanel, self).__init__(session, model_id)

    @classmethod
    def count(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/count"
        return session.call_api(api, attribs, 'get')

    def count_residential_breakers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers/count".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels"
        return session.call_api(api, attribs, 'post')

    def create_access_tokens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/accessTokens".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def create_many(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels"
        return session.call_api(api, attribs, 'post')

    def create_residential_breakers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    def delete_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def delete_residential_breakers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_access_tokens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/accessTokens".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_by_id_residential_breakers(self, residential_breaker_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers/{1}".format(self._id, residential_breaker_id)
        return self._session.call_api(api, attribs, 'delete')

    def discover(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/discover".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    def exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/exists".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def find(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels"
        items = session.call_api(api, attribs, 'get')

        result = []
        if items is not None:
            for data in items:
                model = ResidentialBreakerPanel(session, data['id'])
                model.data = data
                result.append(model)
        return result

    def find_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        self.data.update(data)
        return self

    def find_by_id_residential_breakers(self, residential_breaker_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers/{1}".format(self._id, residential_breaker_id)
        data = self._session.call_api(api, attribs, 'get')

        from .residential_breaker import ResidentialBreaker
        model = ResidentialBreaker(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def find_one(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/findOne"
        return session.call_api(api, attribs, 'get')

    def refresh(self):
        api = "/ResidentialBreakerPanels/{0}".format(self._id)
        result = self._session.call_api(api, {}, 'get')
        if result is not None:
            self.data.update(result)
        return self

    def get_access_tokens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/accessTokens".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    def get_residence(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residence".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .residence import Residence
        model = Residence(self._session, data['id'])
        model.data = data
        return model

    def get_residential_breakers(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers".format(self._id)
        items = self._session.call_api(api, attribs, 'get')

        from .residential_breaker import ResidentialBreaker
        result = []
        if items is not None:
            for data in items:
                model = ResidentialBreaker(self._session, data['id'])
                model.data = data
                result.append(model)
        return result

    def replace_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/replace".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def replace_or_create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/replaceOrCreate"
        return session.call_api(api, attribs, 'post')

    def update_access_tokens(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/accessTokens".format(self._id)
        return self._session.call_api(api, attribs, 'put')

    def update_attributes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'put')

        self.data.update(attribs)
        return self

    def update_by_id_residential_breakers(self, residential_breaker_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/{0}/residentialBreakers/{1}".format(self._id, residential_breaker_id)
        data = self._session.call_api(api, attribs, 'put')

        from .residential_breaker import ResidentialBreaker
        model = ResidentialBreaker(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels"
        data = session.call_api(api, attribs, 'put')

        model = ResidentialBreakerPanel(session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert_with_where(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialBreakerPanels/upsertWithWhere"
        return session.call_api(api, attribs, 'post')

