# Leviton Cloud Services API model ResidentialScene.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ResidentialScene(BaseModel):
    def __init__(self, session, model_id=None):
        super(ResidentialScene, self).__init__(session, model_id)

    @classmethod
    def count(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/count"
        return session.call_api(api, attribs, 'get')

    def count_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/count".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        return session.call_api(api, attribs, 'post')

    @classmethod
    def create_many(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        return session.call_api(api, attribs, 'post')

    def create_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    def delete_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def delete_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def destroy_by_id_residential_actions(self, residential_action_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/{1}".format(self._id, residential_action_id)
        return self._session.call_api(api, attribs, 'delete')

    @classmethod
    def execute(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/execute"
        return session.call_api(api, attribs, 'post')

    def exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/exists".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def find(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        items = session.call_api(api, attribs, 'get')

        result = []
        if items is not None:
            for data in items:
                model = ResidentialScene(session, data['id'])
                model.data = data
                result.append(model)
        return result

    def find_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        self.data.update(data)
        return self

    def find_by_id_residential_actions(self, residential_action_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/{1}".format(self._id, residential_action_id)
        data = self._session.call_api(api, attribs, 'get')

        from .residential_action import ResidentialAction
        model = ResidentialAction(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def find_one(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/findOne"
        return session.call_api(api, attribs, 'get')

    def refresh(self):
        api = "/ResidentialScenes/{0}".format(self._id)
        result = self._session.call_api(api, {}, 'get')
        if result is not None:
            self.data.update(result)
        return self

    def get_residential_actions(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions".format(self._id)
        items = self._session.call_api(api, attribs, 'get')

        from .residential_action import ResidentialAction
        result = []
        if items is not None:
            for data in items:
                model = ResidentialAction(self._session, data['id'])
                model.data = data
                result.append(model)
        return result

    def get_residential_room(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialRoom".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .residential_room import ResidentialRoom
        model = ResidentialRoom(self._session, data['id'])
        model.data = data
        return model

    def replace_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/replace".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def replace_or_create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/replaceOrCreate"
        return session.call_api(api, attribs, 'post')

    def update_attributes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'put')

        self.data.update(attribs)
        return self

    def update_by_id_residential_actions(self, residential_action_id, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/{0}/residentialActions/{1}".format(self._id, residential_action_id)
        data = self._session.call_api(api, attribs, 'put')

        from .residential_action import ResidentialAction
        model = ResidentialAction(self._session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes"
        data = session.call_api(api, attribs, 'put')

        model = ResidentialScene(session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert_with_where(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ResidentialScenes/upsertWithWhere"
        return session.call_api(api, attribs, 'post')

