# Leviton Cloud Services API model ThermostatSnapshot.
# Auto-generated by api_scraper.py.
#
# Copyright 2017 Tim Lyakhovetskiy <tlyakhov@gmail.com>
#
# This code is released under the terms of the MIT license. See the LICENSE
# file for more details.
from decora_wifi.base_model import BaseModel


class ThermostatSnapshot(BaseModel):
    def __init__(self, session, model_id=None):
        super(ThermostatSnapshot, self).__init__(session, model_id)

    @classmethod
    def count(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/count"
        return session.call_api(api, attribs, 'get')

    @classmethod
    def create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots"
        return session.call_api(api, attribs, 'post')

    @classmethod
    def create_change_stream(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/change-stream"
        return session.call_api(api, attribs, 'post')

    @classmethod
    def create_many(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots"
        return session.call_api(api, attribs, 'post')

    def delete_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}".format(self._id)
        return self._session.call_api(api, attribs, 'delete')

    def exists(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}/exists".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    @classmethod
    def find(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots"
        items = session.call_api(api, attribs, 'get')

        result = []
        if items is not None:
            for data in items:
                model = ThermostatSnapshot(session, data['id'])
                model.data = data
                result.append(model)
        return result

    def find_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        self.data.update(data)
        return self

    @classmethod
    def find_one(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/findOne"
        return session.call_api(api, attribs, 'get')

    def refresh(self):
        api = "/ThermostatSnapshots/{0}".format(self._id)
        result = self._session.call_api(api, {}, 'get')
        if result is not None:
            self.data.update(result)
        return self

    def get_area(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}/area".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .area import Area
        model = Area(self._session, data['id'])
        model.data = data
        return model

    def get_device_definition(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}/deviceDefinition".format(self._id)
        return self._session.call_api(api, attribs, 'get')

    def get_installation(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}/installation".format(self._id)
        data = self._session.call_api(api, attribs, 'get')

        from .installation import Installation
        model = Installation(self._session, data['id'])
        model.data = data
        return model

    def replace_by_id(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}/replace".format(self._id)
        return self._session.call_api(api, attribs, 'post')

    @classmethod
    def replace_or_create(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/replaceOrCreate"
        return session.call_api(api, attribs, 'post')

    @classmethod
    def update_all(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/update"
        return session.call_api(api, attribs, 'post')

    def update_attributes(self, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/{0}".format(self._id)
        data = self._session.call_api(api, attribs, 'put')

        self.data.update(attribs)
        return self

    @classmethod
    def upsert(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots"
        data = session.call_api(api, attribs, 'put')

        model = ThermostatSnapshot(session, data['id'])
        model.data = data
        return model

    @classmethod
    def upsert_with_where(cls, session, attribs=None):
        if attribs is None:
            attribs = {}
        api = "/ThermostatSnapshots/upsertWithWhere"
        return session.call_api(api, attribs, 'post')

